/*
 * Decision.java
 *
 * Created on 13 de abril de 2006, 13:35
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package objectgen.activitymodel;

import java.util.ArrayList;
import java.util.Iterator;


/**
 *
 * @author Rincew
 */
public class Decision 
    extends Activity
    implements Iterator
{
    
    //--- Atreibutes --------------------
    protected ArrayList next;
    //--- Iterator attributes -----------
    int index;
    int size;
    
    /** Creates a new instance of Decision */
    public Decision () {
        super();
        this.next = new ArrayList();
    }
    
    /** Always returns true **/
    public boolean isDesicion() {
      return true;
    }
    
    /** Always returns null **/    
    public Activity getNext () {
        return null;
    }

    /** Add a new alternative branch **/
    public void setAlternative (Alternative alternative) {
        this.next.add (alternative);
    }
    
    /** Paths has only one alternative **/
    public Alternative getFirstAlternative() {
        return (Alternative)this.next.get (0);
    }

    
    //-- Iterator methods -------------------
    
    public Iterator iterator() {
        this.index = -1;
        this.size = this.next.size ();
        return this;
    }
    
    public boolean hasNext () {
        return (this.index < (this.size-1));
    }

    public Object next () {
        if (this.size != this.next.size() )
            throw new java.lang.AbstractMethodError();
        
        if (this.index >= this.size)
            throw new java.lang.AbstractMethodError();
        
        return this.next.get((++this.index));
                
    }

    /** Not implemented ***/
    public void remove () {
        throw new java.lang.AbstractMethodError();
    }

    /** For testing purpouse **/
    public String toString() {
        String s = id + ": " + description + "\n" ;
        int c;
        for (c = 0; c < this.next.size (); c++) {
            s +=  ((Alternative) this.next.get (c) );
            s += " / ";
        }
        return s;
    }

}
