/*
 * StepBuilder.java
 *
 * Created on 22 de abril de 2006, 11:12
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package objectgen.usecase;

import org.w3c.dom.Node;

/**
 * This class builds a Step object from a Node object
 * It is called from UseCaseXML, due that class does not return any
 * XML element.
 *
 */
public class StepBuilder {
    
    //IStep s;
    Node nAux;
        
    /** Creates a new instance of StepBuilder */
    public StepBuilder () {
    }
    
    public IStep builMainStep(Node n) {
        
        IStep s = new Step();
        
        buildId(s, n);
        buildDescription(s, n);        
        
        return s;
    }
    
    void buildId(IStep s, Node n) {
        Node nAux;
        
        nAux = n.getAttributes ().getNamedItem ("id");
        s.setId (nAux.getNodeValue ());
    }
    
    void buildDescription(IStep s, Node n) {
        Node nAux;
        
        /*if (n.getNodeType () != Node.TEXT_NODE) {
            System.err.println ("Error. No node text.");
        }*/
        
        if (n.getFirstChild().getNodeType () != Node.TEXT_NODE) {
            System.err.println ("Error. No first child is text.");
        }

        s.setDescription (n.getFirstChild().getNodeValue ());
    }
    
}
