/*
 * Main.java
 *
 * Created on 13 de abril de 2006, 13:31
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package objectgen;

import objectgen.activitymodel.*;
import objectgen.testobjective.*;
import objectgen.usecase.*;

import java.io.File;
import java.util.Iterator;

import org.apache.log4j.BasicConfigurator;

/**
 * Test class
 * @author Rincew
 */
public class Main {
    
    /** Creates a new instance of Main */
    public Main () {
    }
    

    public void test0() {
        Activity a1, a2, a3;
        Activity f;
        
        // Construimos el diagrama;
        
        f = Activity.BuildFinal();
        
        a2 = new Activity();
        a2.setId ("1");

        a1 = new Activity();
        a1.setId ("2");


        a3 = new Activity();
        a3.setId ("3");
        a3.setNext (f);

        a2.setNext (a1);
        a1.setNext (a3);        
        
        System.out.println("Diagrama:");
        System.out.println(""+a2);
        System.out.println(""+a1);
        //System.out.println(""+a1.getNext ());
        System.out.println("--------------------");
        System.out.println("Buscando caminos:");
        
        TestObjectiveGenerator tog = new TestObjectiveGenerator();
        tog.generate (a2);
        
    }
    

//-----------------------------

    public void test1() {
        Activity a1, a2;
        Activity f;
        Decision s;
        Alternative al;
        
        // Construimos el diagrama;
        
        f = Activity.BuildFinal();
        
        a2 = new Activity();
        a2.setId ("1");
        
        s = new Decision();
        a2.setNext (s);
        s.setId ("D1");

        a1 = new Activity();
        a1.setId ("2");
        a1.setNext (f);
        
        al = new Alternative();
        al.setCondition ("True");
        al.setNext (a1);
        s.setAlternative (al);

        a1 = new Activity();
        a1.setId ("3");
        a1.setNext (f);
        
        al = new Alternative();
        al.setCondition ("False");
        al.setNext (a1);
        s.setAlternative (al);
        
        System.out.println("Diagrama:");
        System.out.println(""+a2);
        System.out.println(""+s);
        System.out.println("--------------------");
        System.out.println("Buscando caminos:");
        
        TestObjectiveGenerator tog = new TestObjectiveGenerator();
        tog.generate (a2);
        
    }
    

//-----------------------------
        public void test2() {
        Activity a1, a2;
        Activity f;
        Decision s, s2;
        Alternative al;
        
        // Construimos el diagrama;
        
        f = Activity.BuildFinal();
        
        a2 = new Activity();
        a2.setId ("1");
        
        s = new Decision();
        a2.setNext (s);
        s.setId ("D1");

        s2 = new Decision();
        s2.setId ("D2");
        
        al = new Alternative();
        al.setCondition ("True");
        al.setNext (s2);
        s.setAlternative (al);
        
        a1 = new Activity();
        a1.setId ("2");
        a1.setNext (f);
        
        al = new Alternative();
        al.setCondition ("False");
        al.setNext (a1);
        s.setAlternative (al);

        a1 = new Activity();
        a1.setId ("3");
        a1.setNext (f);

        al = new Alternative();
        al.setCondition ("true");
        al.setNext (a1);
        s2.setAlternative (al);

        al = new Alternative();
        al.setCondition ("false");
        al.setNext (f);
        s2.setAlternative (al);

        System.out.println("Diagrama:");
        System.out.println(""+a2);
        System.out.println(""+s);
        System.out.println(""+s2);
        System.out.println(""+a1);
        System.out.println("--------------------");
        System.out.println("Buscando caminos:");
        
        TestObjectiveGenerator tog = new TestObjectiveGenerator();
        tog.generate (a2);
        
        
        
    }

    //-----------------------------
    public void test3() {
        Activity a2;
        Activity f;
        Decision s;
        Alternative al;
        
        // Construimos el diagrama;
        
        f = Activity.BuildFinal();
        
        a2 = new Activity();
        a2.setId ("1");
        
        s = new Decision();
        a2.setNext (s);
        s.setId ("D1");

        al = new Alternative();
        al.setCondition ("True");
        al.setNext (f);
        s.setAlternative (al);
        
        al = new Alternative();
        al.setCondition ("False");
        al.setNext (f);
        s.setAlternative (al);


        System.out.println("Diagrama:");
        System.out.println(""+a2);
        System.out.println(""+s);
        System.out.println("--------------------");
        System.out.println("Buscando caminos:");
        
        TestObjectiveGenerator tog = new TestObjectiveGenerator();
        tog.generate (a2);
        
    }
        
    
    //-------------------------------------------
    static void testUseCase01() 
        throws Exception
    {
        Iterator it;
        File f = new File("C:/Code/TestApps/ObjectGen/sample_files/CU-Link 02.xml");
        UseCaseXML uc = new UseCaseXML();
        uc.load (f);
        
        System.out.println(uc);
        
        ActivityDiagram ad;
        ActivityDiagramGenerator adg = new ActivityDiagramGenerator();
        ad = adg.generate (uc);
        
        System.out.println(ad);
        
        TestObjectiveGenerator tog = new TestObjectiveGenerator();
        TestObjectiveList tol = tog.generate (ad);
        
        System.out.println("Objectives:");
        System.out.println(tol);
        
        System.out.println ("Ok.");
        
    }

    //-------------------------------------------
    static void testUseCase02() 
        throws Exception
    {
        Iterator it;
        File f = new File("C:/Code/TestApps/ObjectGen/sample_files/CU-Link 02.xml");
        UseCaseXML uc = new UseCaseXML();
        uc.load (f);
        
        System.out.println(uc);
        
        ActivityDiagram ad;
        ActivityDiagramGenerator adg = new ActivityDiagramGenerator();
        ad = adg.generate (uc);
        
        System.out.println(ad);
        
        TestObjectiveGenerator tog = new TestObjectiveGenerator();
        TestObjectiveList tol = tog.generate (ad);
        
        System.out.println("Objectives:");
        System.out.println(tol);
        
        
        
        f = new File("C:/Code/TestApps/ObjectGen/sample_files/prueba.xmi");
        XMIFileSaver fs = new XMIFileSaver();
        fs.save (f, ad);
        
        System.out.println ("Ok.");
        
    }

    /**
     * @param args the command line arguments
     */
    public static void main (String[] args) 
        throws Exception
    {
        
        //--- Configure logs -----------
        BasicConfigurator.configure ();
        
        Main m = new Main();
        
        //m.test0();
        System.out.println("----------------");
        //m.test3();
        System.out.println("----------------");
        /*m.test1();
        System.out.println("----------------");
        m.test2();*/
        //testUseCase01();
        testUseCase02();
    }
    
}
